﻿using System;

namespace Katteker
{
    /// <summary>
    /// Represent an error message in the Katteker update process.
    /// </summary>
    public class KattekerUpdateException : Exception
    {
        /// <summary>
        /// Creates a new instance of the <see cref="KattekerUpdateException"/> class with the error message.
        /// </summary>
        public KattekerUpdateException(string message) : base(message)
        {
        }

        /// <summary>
        /// Creates a new instance of the <see cref="KattekerUpdateException"/> with the error message and inner exception.
        /// </summary>
        public KattekerUpdateException(string message, Exception innerException) : base(message, innerException)
        {
        }
    }
}